/* Generated by re2c 2.1.1 on Thu Jul 22 23:55:35 2021 */
#line 1 "TRConfigLexer.re"
/*
 * TRConfigLexer.re vi:ts=4:sw=4:expandtab:
 * Configuration Lexer
 *
 * Author: Landon Fuller <landonf@threerings.net>
 *
 * Copyright (c) 2006 - 2007 Three Rings Design, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holders nor the names of any contributors
 *    may be used to endorse or promote products derived from this
 *    software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

#ifdef HAVE_CONFIG_H
#import <config.h>
#endif

#import <stdio.h>
#import <assert.h>
#import <sys/types.h>
#import <sys/stat.h>
#import <sys/mman.h>

#import "TRConfig.h"
#import "TRConfigLexer.h"
#import "TRConfigParser.h"

/*
 * re2c Configuration
 */
#define YYCTYPE     char        /* Input Symbol Type */
#define YYCURSOR    _cursor     /* L-expression of type *YYCTYPE that points to the current input symbol */
#define YYLIMIT     _limit      /* Expression of type *YYCTYPE that marks the end of the buffer */
#define YYMARKER    _marker     /* L-expression of type *YYCTYPE that is used for backtracking information */
#define YYCTXMARKER _ctxMarker  /* L-expression of type *YYCTYPE that is used for trailing context back tracking information */
#define YYFILL(n)   [self fill: n]  /* YYFILL(n) is called when the buffer needs (re)filling */

#define YYDEBUG(state, current) printf("state: %d, current: '%c' (%d)\n", state, current, current);

/*
 * Macros
 */

/* Increment line count */
#define INCR_LINE()    _lineNumber++

/* Switch to a start condition */
#define BEGIN(cond)    ( _condition = LEXER_SC_ ## cond)

/* Declare a start condition */
#define SC(cond)    LEXER_SC_ ## cond: LEXER_SC_ ## cond

/* Check for end-of-input */
#define CHECK_EOI()    if (_eoi) { return NULL; }

/* Skip a token */
#define SKIP(cond)    CHECK_EOI(); goto LEXER_SC_ ## cond

/* Get the current token length */
#define TOKEN_LENGTH()    (_cursor - _token)

@implementation TRConfigLexer

- (void) dealloc {
    if (buffer)
        munmap(buffer, bufferLength);
    [super dealloc];
}

- (id) initWithFD: (int) fd {
    struct stat statbuf;

    /* Initialize */
    self = [self init];
    if (self == NULL)
        return (self);

    /* Mmap() source file
     * Unless our caller botched something, this should never fail */
    assert((fstat(fd, &statbuf) == 0));
    bufferLength = statbuf.st_size;
    buffer = mmap(NULL, bufferLength, PROT_READ, MAP_SHARED, fd, 0);
    assert(buffer != MAP_FAILED);

    /* Initialize lexer state */
    _lineNumber = 1;
    _condition = LEXER_SC_INITIAL;
    _cursor = buffer;
    _limit = _cursor + bufferLength - 1;

    return (self);
}

- (void) fill: (int) length {
    /* We just need to prevent re2c from walking off the end of our buffer */
    assert(_limit - _cursor >= 0);
    if (_cursor == _limit) {
        /* Save the cursor and signal EOI */
        _eoi = _cursor;
    }
}

- (TRConfigToken *) scan {
    TRConfigToken *token;
    #line 129 "TRConfigLexer.re"


    /* Test for EOI before scanning */
    CHECK_EOI();

    switch (_condition) {
        case SC(INITIAL):
            _token = _cursor;
            
#line 139 "TRConfigLexer.m"
{
	YYCTYPE yych;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
	case '\t':
	case ' ':	goto yy4;
	case '\n':	goto yy7;
	case '#':	goto yy9;
	case '-':
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	case 'A':
	case 'B':
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'G':
	case 'H':
	case 'I':
	case 'J':
	case 'K':
	case 'L':
	case 'M':
	case 'N':
	case 'O':
	case 'P':
	case 'Q':
	case 'R':
	case 'S':
	case 'T':
	case 'U':
	case 'V':
	case 'W':
	case 'X':
	case 'Y':
	case 'Z':
	case '_':
	case 'a':
	case 'b':
	case 'c':
	case 'd':
	case 'e':
	case 'f':
	case 'g':
	case 'h':
	case 'i':
	case 'j':
	case 'k':
	case 'l':
	case 'm':
	case 'n':
	case 'o':
	case 'p':
	case 'q':
	case 'r':
	case 's':
	case 't':
	case 'u':
	case 'v':
	case 'w':
	case 'x':
	case 'y':
	case 'z':	goto yy12;
	case '<':	goto yy15;
	default:	goto yy2;
	}
yy2:
	++YYCURSOR;
#line 171 "TRConfigLexer.re"
	{
                // TODO explode here
                printf("Unknown character: '%c' (%d)\n", yych, yych);
                return NULL;
            }
#line 224 "TRConfigLexer.m"
yy4:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
	case '\t':
	case ' ':	goto yy4;
	default:	goto yy6;
	}
yy6:
#line 140 "TRConfigLexer.re"
	{
                SKIP(INITIAL);
            }
#line 239 "TRConfigLexer.m"
yy7:
	++YYCURSOR;
#line 165 "TRConfigLexer.re"
	{
                INCR_LINE();
                SKIP(INITIAL);
            }
#line 247 "TRConfigLexer.m"
yy9:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
	case '\n':	goto yy11;
	default:	goto yy9;
	}
yy11:
#line 145 "TRConfigLexer.re"
	{
                SKIP(INITIAL);
            }
#line 261 "TRConfigLexer.m"
yy12:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
	case '-':
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	case 'A':
	case 'B':
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'G':
	case 'H':
	case 'I':
	case 'J':
	case 'K':
	case 'L':
	case 'M':
	case 'N':
	case 'O':
	case 'P':
	case 'Q':
	case 'R':
	case 'S':
	case 'T':
	case 'U':
	case 'V':
	case 'W':
	case 'X':
	case 'Y':
	case 'Z':
	case '_':
	case 'a':
	case 'b':
	case 'c':
	case 'd':
	case 'e':
	case 'f':
	case 'g':
	case 'h':
	case 'i':
	case 'j':
	case 'k':
	case 'l':
	case 'm':
	case 'n':
	case 'o':
	case 'p':
	case 'q':
	case 'r':
	case 's':
	case 't':
	case 'u':
	case 'v':
	case 'w':
	case 'x':
	case 'y':
	case 'z':	goto yy12;
	default:	goto yy14;
	}
yy14:
#line 150 "TRConfigLexer.re"
	{
                token = [[TRConfigToken alloc] initWithBytes: _token
                                    numBytes: TOKEN_LENGTH()
                                  lineNumber: _lineNumber
                                     tokenID: TOKEN_KEY];
                BEGIN(VALUE);
                return token;
            }
#line 343 "TRConfigLexer.m"
yy15:
	++YYCURSOR;
#line 160 "TRConfigLexer.re"
	{
                SKIP(SECTION);
            }
#line 350 "TRConfigLexer.m"
}
#line 177 "TRConfigLexer.re"


            break;

        /* Section Declarations */
        case SC(SECTION):
            _token = _cursor;
            
#line 361 "TRConfigLexer.m"
{
	YYCTYPE yych;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	switch (yych) {
	case '\n':	goto yy20;
	case '-':
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	case 'A':
	case 'B':
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'G':
	case 'H':
	case 'I':
	case 'J':
	case 'K':
	case 'L':
	case 'M':
	case 'N':
	case 'O':
	case 'P':
	case 'Q':
	case 'R':
	case 'S':
	case 'T':
	case 'U':
	case 'V':
	case 'W':
	case 'X':
	case 'Y':
	case 'Z':
	case '_':
	case 'a':
	case 'b':
	case 'c':
	case 'd':
	case 'e':
	case 'f':
	case 'g':
	case 'h':
	case 'i':
	case 'j':
	case 'k':
	case 'l':
	case 'm':
	case 'n':
	case 'o':
	case 'p':
	case 'q':
	case 'r':
	case 's':
	case 't':
	case 'u':
	case 'v':
	case 'w':
	case 'x':
	case 'y':
	case 'z':	goto yy22;
	case '/':	goto yy24;
	default:	goto yy19;
	}
yy19:
yy20:
	++YYCURSOR;
#line 217 "TRConfigLexer.re"
	{
                INCR_LINE();
                SKIP(INITIAL);
            }
#line 443 "TRConfigLexer.m"
yy22:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
	case '\t':
	case ' ':
		YYCTXMARKER = YYCURSOR;
		goto yy25;
	case '-':
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	case 'A':
	case 'B':
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'G':
	case 'H':
	case 'I':
	case 'J':
	case 'K':
	case 'L':
	case 'M':
	case 'N':
	case 'O':
	case 'P':
	case 'Q':
	case 'R':
	case 'S':
	case 'T':
	case 'U':
	case 'V':
	case 'W':
	case 'X':
	case 'Y':
	case 'Z':
	case '_':
	case 'a':
	case 'b':
	case 'c':
	case 'd':
	case 'e':
	case 'f':
	case 'g':
	case 'h':
	case 'i':
	case 'j':
	case 'k':
	case 'l':
	case 'm':
	case 'n':
	case 'o':
	case 'p':
	case 'q':
	case 'r':
	case 's':
	case 't':
	case 'u':
	case 'v':
	case 'w':
	case 'x':
	case 'y':
	case 'z':	goto yy22;
	case '>':	goto yy28;
	default:	goto yy19;
	}
yy24:
	yych = *++YYCURSOR;
	switch (yych) {
	case '>':	goto yy19;
	default:	goto yy31;
	}
yy25:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
	case '\t':
	case ' ':	goto yy25;
	default:	goto yy27;
	}
yy27:
	YYCURSOR = YYCTXMARKER;
#line 197 "TRConfigLexer.re"
	{
                token = [[TRConfigToken alloc] initWithBytes: _token
                                    numBytes: TOKEN_LENGTH()
                                  lineNumber: _lineNumber
                                     tokenID: TOKEN_SECTION_START];
                BEGIN(SECTION_NAME);
                return token;
            }
#line 546 "TRConfigLexer.m"
yy28:
	++YYCURSOR;
#line 187 "TRConfigLexer.re"
	{
                /* Drop the trailing ">" */
                token = [[TRConfigToken alloc] initWithBytes: _token
                                    numBytes: TOKEN_LENGTH() - 1
                                  lineNumber: _lineNumber
                                     tokenID: TOKEN_SECTION_START];
                return token;
            }
#line 558 "TRConfigLexer.m"
yy30:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
yy31:
	switch (yych) {
	case '-':
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	case 'A':
	case 'B':
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'G':
	case 'H':
	case 'I':
	case 'J':
	case 'K':
	case 'L':
	case 'M':
	case 'N':
	case 'O':
	case 'P':
	case 'Q':
	case 'R':
	case 'S':
	case 'T':
	case 'U':
	case 'V':
	case 'W':
	case 'X':
	case 'Y':
	case 'Z':
	case '_':
	case 'a':
	case 'b':
	case 'c':
	case 'd':
	case 'e':
	case 'f':
	case 'g':
	case 'h':
	case 'i':
	case 'j':
	case 'k':
	case 'l':
	case 'm':
	case 'n':
	case 'o':
	case 'p':
	case 'q':
	case 'r':
	case 's':
	case 't':
	case 'u':
	case 'v':
	case 'w':
	case 'x':
	case 'y':
	case 'z':	goto yy30;
	case '>':	goto yy32;
	default:	goto yy19;
	}
yy32:
	++YYCURSOR;
#line 207 "TRConfigLexer.re"
	{
                /* Drop the leading '/' and trailing ">" */
                token = [[TRConfigToken alloc] initWithBytes: _token + 1
                                    numBytes: TOKEN_LENGTH() - 2
                                  lineNumber: _lineNumber
                                     tokenID: TOKEN_SECTION_END];
                return token;
            }
#line 643 "TRConfigLexer.m"
}
#line 222 "TRConfigLexer.re"


            break;

        case SC(SECTION_NAME):
            _token = _cursor;
            
#line 653 "TRConfigLexer.m"
{
	YYCTYPE yych;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
	case '\t':
	case ' ':	goto yy37;
	case '\n':	goto yy40;
	case '-':
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	case 'A':
	case 'B':
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'G':
	case 'H':
	case 'I':
	case 'J':
	case 'K':
	case 'L':
	case 'M':
	case 'N':
	case 'O':
	case 'P':
	case 'Q':
	case 'R':
	case 'S':
	case 'T':
	case 'U':
	case 'V':
	case 'W':
	case 'X':
	case 'Y':
	case 'Z':
	case '_':
	case 'a':
	case 'b':
	case 'c':
	case 'd':
	case 'e':
	case 'f':
	case 'g':
	case 'h':
	case 'i':
	case 'j':
	case 'k':
	case 'l':
	case 'm':
	case 'n':
	case 'o':
	case 'p':
	case 'q':
	case 'r':
	case 's':
	case 't':
	case 'u':
	case 'v':
	case 'w':
	case 'x':
	case 'y':
	case 'z':	goto yy42;
	default:	goto yy36;
	}
yy36:
yy37:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
	case '\t':
	case ' ':	goto yy37;
	default:	goto yy39;
	}
yy39:
#line 230 "TRConfigLexer.re"
	{
                SKIP(SECTION_NAME);
            }
#line 743 "TRConfigLexer.m"
yy40:
	++YYCURSOR;
#line 246 "TRConfigLexer.re"
	{
                INCR_LINE();
                SKIP(INITIAL);
            }
#line 751 "TRConfigLexer.m"
yy42:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
	case '-':
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	case 'A':
	case 'B':
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'G':
	case 'H':
	case 'I':
	case 'J':
	case 'K':
	case 'L':
	case 'M':
	case 'N':
	case 'O':
	case 'P':
	case 'Q':
	case 'R':
	case 'S':
	case 'T':
	case 'U':
	case 'V':
	case 'W':
	case 'X':
	case 'Y':
	case 'Z':
	case '_':
	case 'a':
	case 'b':
	case 'c':
	case 'd':
	case 'e':
	case 'f':
	case 'g':
	case 'h':
	case 'i':
	case 'j':
	case 'k':
	case 'l':
	case 'm':
	case 'n':
	case 'o':
	case 'p':
	case 'q':
	case 'r':
	case 's':
	case 't':
	case 'u':
	case 'v':
	case 'w':
	case 'x':
	case 'y':
	case 'z':	goto yy42;
	case '>':	goto yy44;
	default:	goto yy36;
	}
yy44:
	++YYCURSOR;
#line 235 "TRConfigLexer.re"
	{
                /* Drop the trailing ">" */
                token = [[TRConfigToken alloc] initWithBytes: _token
                                    numBytes: TOKEN_LENGTH() - 1
                                  lineNumber: _lineNumber
                                     tokenID: TOKEN_SECTION_NAME];
                BEGIN(INITIAL);
                return token;
            }
#line 836 "TRConfigLexer.m"
}
#line 251 "TRConfigLexer.re"


        /* Values */
        case SC(VALUE):
            _token = _cursor;
            
#line 845 "TRConfigLexer.m"
{
	YYCTYPE yych;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
	case '\t':
	case ' ':	goto yy51;
	case '\n':	goto yy54;
	case '"':	goto yy56;
	case '#':	goto yy58;
	default:	goto yy48;
	}
yy48:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
	case '\t':
	case '\n':
	case ' ':
	case '"':	goto yy50;
	default:	goto yy48;
	}
yy50:
#line 272 "TRConfigLexer.re"
	{ /* " vim syntax fix */
                token = [[TRConfigToken alloc] initWithBytes: _token
                                    numBytes: TOKEN_LENGTH()
                                  lineNumber: _lineNumber
                                     tokenID: TOKEN_VALUE];
                return token;
            }
#line 878 "TRConfigLexer.m"
yy51:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
	case '\t':
	case ' ':	goto yy51;
	default:	goto yy53;
	}
yy53:
#line 257 "TRConfigLexer.re"
	{
                SKIP(VALUE);
            }
#line 893 "TRConfigLexer.m"
yy54:
	++YYCURSOR;
#line 281 "TRConfigLexer.re"
	{
                INCR_LINE();
                SKIP(INITIAL);
            }
#line 901 "TRConfigLexer.m"
yy56:
	++YYCURSOR;
#line 267 "TRConfigLexer.re"
	{
                SKIP(STRING_VALUE);
            }
#line 908 "TRConfigLexer.m"
yy58:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
	case '\n':	goto yy60;
	default:	goto yy58;
	}
yy60:
#line 262 "TRConfigLexer.re"
	{
                SKIP(VALUE);
            }
#line 922 "TRConfigLexer.m"
}
#line 286 "TRConfigLexer.re"

            break;

        /* Quoted string values */
        case SC(STRING_VALUE):
            _token = _cursor;

            
#line 933 "TRConfigLexer.m"
{
	YYCTYPE yych;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
	case '"':	goto yy63;
	case '#':	goto yy66;
	default:	goto yy64;
	}
yy63:
yy64:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
	case '"':	goto yy68;
	default:	goto yy64;
	}
yy66:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
	case '\n':	goto yy64;
	case '"':	goto yy70;
	default:	goto yy66;
	}
yy68:
	++YYCURSOR;
#line 302 "TRConfigLexer.re"
	{
                /* Skip the trailing '"' */
                token = [[TRConfigToken alloc] initWithBytes: _token
                                    numBytes: TOKEN_LENGTH() - 1
                                  lineNumber: _lineNumber
                                     tokenID: TOKEN_VALUE];
                return token;
            }
#line 972 "TRConfigLexer.m"
yy70:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
	case '\n':	goto yy72;
	default:	goto yy70;
	}
yy72:
#line 296 "TRConfigLexer.re"
	{
                SKIP(STRING_VALUE);
            }
#line 986 "TRConfigLexer.m"
}
#line 317 "TRConfigLexer.re"

            break;

        default:
            /* Impossible */
            assert(0);
    }

    /* Never reached */
    return nil;
}

@end
